package de.intevation.flys.artifacts.model;

import de.intevation.artifacts.Artifact;
import de.intevation.artifacts.CallContext;

import de.intevation.artifactdatabase.state.DefaultFacet;

import de.intevation.flys.artifacts.FLYSArtifact;

import de.intevation.flys.artifacts.states.DefaultState.ComputeType;

public class DataFacet
extends      DefaultFacet
{
    protected ComputeType type;
    protected String      hash;

    public DataFacet(String name, String description) {
        this(name, description, ComputeType.ADVANCE);
    }

    public DataFacet(String name, String description, ComputeType type) {
        this(name, description, type, null);
    }

    public DataFacet(
        String      name,
        String      description, 
        ComputeType type,
        String      hash
    ) {
        super(name, description);
        this.type = type;
        this.hash = hash;
    }

    public Object getData(Artifact artifact, CallContext context) {
        FLYSArtifact flys = (FLYSArtifact)artifact;
        return flys.compute(
            context, hash != null ? hash : flys.hash(), type);
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8 :
